import transportRest from '@graphql-mesh/transport-rest';
import { loadGraphQLSchemaFromJSONSchemas, loadNonExecutableGraphQLSchemaFromJSONSchemas, } from './loadGraphQLSchemaFromJSONSchemas.js';
export default loadGraphQLSchemaFromJSONSchemas;
export * from './loadGraphQLSchemaFromJSONSchemas.js';
export * from './getComposerFromJSONSchema.js';
export * from './getDereferencedJSONSchemaFromOperations.js';
export * from './getGraphQLSchemaFromDereferencedJSONSchema.js';
export function loadJSONSchemaSubgraph(name, options) {
    return (ctx) => ({
        name,
        schema$: loadNonExecutableGraphQLSchemaFromJSONSchemas(name, {
            ...options,
            fetch: ctx.fetch,
            cwd: ctx.cwd,
            logger: ctx.logger,
        }),
    });
}
export { processDirectives } from '@graphql-mesh/transport-rest';
export const getSubgraphExecutor = opts => {
    return transportRest.getSubgraphExecutor(opts);
};
