import type { GraphQLScalarType } from 'graphql';
import type { SchemaComposer } from 'graphql-compose';
import type { IStringifyOptions } from 'qs';
import type { Logger } from '@graphql-mesh/types';
import type { JSONSchemaOperationConfig, OperationHeadersConfiguration } from './types.js';
export interface AddExecutionLogicToComposerOptions {
    schemaComposer: SchemaComposer;
    endpoint: string;
    operations: JSONSchemaOperationConfig[];
    operationHeaders?: OperationHeadersConfiguration;
    logger: Logger;
    queryParams?: Record<string, string | number | boolean>;
    queryStringOptions?: IStringifyOptions;
    getScalarForFormat?: (format: string) => GraphQLScalarType | void;
    handlerName?: string;
}
export declare function addExecutionDirectivesToComposer(subgraphName: string, { schemaComposer, logger, operations, operationHeaders, endpoint, queryParams, queryStringOptions, handlerName, }: AddExecutionLogicToComposerOptions): import("graphql").GraphQLSchema;
