import type { JSONSchemaObject } from 'json-machete';
import type { Logger, MeshFetch } from '@graphql-mesh/types';
import type { JSONSchemaOperationConfig } from './types.js';
export declare function getDereferencedJSONSchemaFromOperations({ operations, cwd, logger, fetchFn, schemaHeaders, ignoreErrorResponses, endpoint, operationHeaders, queryParams, }: {
    operations: JSONSchemaOperationConfig[];
    cwd: string;
    logger: Logger;
    fetchFn: MeshFetch;
    schemaHeaders?: Record<string, string>;
    ignoreErrorResponses?: boolean;
    endpoint: string;
    operationHeaders: Record<string, string>;
    queryParams: Record<string, string | number | boolean>;
}): Promise<JSONSchemaObject>;
